using System;
using System.Collections.Generic;
using System.Text;
using System.IO;
using System.Text.RegularExpressions;
using System.Collections.ObjectModel;

namespace LocalizeMe.ResourceTool.VSTools
{
	class VSProject
	{
		private string _name;
		private string _filepath;
        private Collection<VSItem> _items;

		public string Name
		{
			get
			{
				return _name;
			}
		}

		public Collection<VSItem> Items
		{
			get
			{
				if (_items == null)
					_items = new Collection<VSItem>();
				return _items;
			}
		}

		public string FilePath
		{
			get
			{
				return _filepath;
			}
		}

		public VSProject(string name, string path)
		{
			_filepath = path;
			_name = name;
		}

		public VSProject AnalyzeFile()
		{
			if (File.Exists(this.FilePath))
			{
				StreamReader sr = new StreamReader(this.FilePath);
				try
				{
					string content=sr.ReadToEnd();
					Regex reg = new Regex("<Compile\\sInclude=\"(?<FileName>[^\"]*)\"");
					MatchCollection matches = reg.Matches(content);
					foreach (Match match in matches)
					{
						if (match.Groups["FileName"].Success)
						{
							string fileName=match.Groups["FileName"].Value;
							FileInfo fi=new FileInfo(this.FilePath);

                            VSItem item=null;
							//On construit les rpertoires si il y a bsoin...
							string[] dirs=fileName.Split('\\');


							if (dirs.Length > 1)
							{
								for(int i=0;i<dirs.Length-1;i++)
								{
                                    bool bFound=false;

                                    if (item == null)
                                    {
                                        foreach (VSItem it in this.Items)
                                        {
                                            if (it.IsFolder && it.Name.Equals(dirs[i]))
                                            {
                                                item = it;
                                                bFound = true;
                                                break;
                                            }
                                        }

                                        if (!bFound)
                                        {
                                            
                                            item = new VSItem(dirs[i], string.Empty, true);
                                            this.Items.Add(item);
                                        }
                                    }
                                    else
                                    {
                                        foreach (VSItem it in item.SubItems)
                                        {
                                            if (it.IsFolder && it.Name.Equals(dirs[i]))
                                            {
                                                item = it;
                                                bFound = true;
                                                break;
                                            }
                                        }

                                        if (!bFound)
                                        {
                                            VSItem tmp = new VSItem(dirs[i], string.Empty, true);
                                            item.SubItems.Add(tmp);
                                            item = tmp;
                                        }
                                    }
								}
							}

							string path = Path.Combine(fi.DirectoryName, fileName);

							if (File.Exists(path))
							{
                                
                                VSItem file = new VSItem(dirs[dirs.Length-1], path, false);
                                if (item != null)
                                    item.SubItems.Add(file);
                                else
								    this.Items.Add(file);
							}
						}
					}
				}
				catch (IOException ioex)
				{
				}
				catch (OutOfMemoryException outmemex)
				{
				}
				finally
				{
					sr.Dispose();
				}
			}
			return this;
		}
		
	}
}
